#pragma once

#include "CoreMinimal.h"
#include "UObject/NoExportTypes.h"
#include "LightingSpecifics.h"
#include "LightingHelper.generated.h"

class ABaseSky;
class AActor;
class ULightingInterpolator;
class ULightingFactory;
class UEnvironmentFactory;
class UPostProcessComponent;
class UTextureCube;
class UActorComponent;

UCLASS(Blueprintable)
class DEADBYDAYLIGHT_API ULightingHelper : public UObject
{
	GENERATED_BODY()

private:
	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	ABaseSky* _levelLighting;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	ABaseSky* _levelLightingFixed;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	ABaseSky* _levelLightingSpawned;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	ABaseSky* _levelLightingWithoutExposure;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	AActor* _environment;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	AActor* _adaptiveShadowMapControllersActor;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	ULightingInterpolator* _lightingInterpolator;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	ULightingFactory* _lightingFactory;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	UEnvironmentFactory* _environmentFactory;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, Instanced, meta=(AllowPrivateAccess=true))
	UPostProcessComponent* _postProcessCache;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	bool _bIsChangeCondition;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	FName _changeLightingThemeName;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FLightingSpecifics _lightingSpecifics;

public:
	UFUNCTION(BlueprintCallable)
	void ToggleLightingChange(bool bActivateLightingChange, FName themeName);

	UFUNCTION(BlueprintCallable)
	UTextureCube* GetTextureCube(FName mapTheme);

	UFUNCTION(BlueprintCallable)
	UClass* GetSourceLevelLightingClass();

	UFUNCTION(BlueprintCallable)
	UActorComponent* GetInitialComponentState(FName componentName);

	UFUNCTION(BlueprintCallable)
	AActor* GetASMController();

private:
	UFUNCTION(BlueprintCallable, Exec)
	void DBD_ModifyExposure(float value);

public:
	ULightingHelper();
};

FORCEINLINE uint32 GetTypeHash(const ULightingHelper) { return 0; }
